#include <fstream>
using namespace std;
ifstream f1("hoanvi.inp");
ofstream f2("hoanvi.out");
int n,a[20];
bool kt(int i,int j)
{
    for (int x = 1; x < j; x++)
    {
        if (i == a[x]) return false;
    }
    return true;
}
void ra()
{
    for (int x = 1; x <= n; x++)
    {
        f2 << a[x] << " ";
    }
    f2 << endl;
}
int doi(int i)
{
    for (int j = 1; j <= n; j++)
    {
        if (kt(j,i) == 1)
        {
            a[i] = j;
            if (i == n) ra();
            else doi(i+1);
        }
    }
}
int main()
{
    f1 >> n;
    doi(1);
    return 0;
}
